package com.lightinit.hsdatashow.impl.ms;

import com.lightinit.hsdatashow.entity.*;
import com.lightinit.hsdatashow.mapper.EducationalPortraitMapper;
import com.lightinit.hsdatashow.mapper.HealthCarePlanMapper;
import com.lightinit.hsdatashow.model.ResultState;
import com.lightinit.hsdatashow.model.ResultStateCode;
import com.lightinit.hsdatashow.service.ms.IMSEducationalPortraitService;
import com.lightinit.hsdatashow.service.ms.IMSHealthCarePlanService;
import com.lightinit.hsdatashow.spring.DynamicDataContextHolder;
import org.springframework.beans.BeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service
public class MSHealthCarePlanServiceImpl implements IMSHealthCarePlanService {
    @Autowired
    private HealthCarePlanMapper healthCarePlanMapper;
    @Override
    public List<HealthCarePlan> queryList(BaseExample.Page pager) {
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        HealthCarePlanExample example = new HealthCarePlanExample();
        example.setPage(pager);
        return healthCarePlanMapper.selectByExample(example);
    }

    @Override
    public long queryCount(BaseExample.Page pager) {
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        HealthCarePlanExample example = new HealthCarePlanExample();
        example.setPage(pager);
        return healthCarePlanMapper.countByExample(example);
    }

    @Override
    public ResultState<Long> delete(long id) {
        ResultState<Long> resultState = new ResultState<Long>();
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        if (!(healthCarePlanMapper.deleteByPrimaryKey(id)>0)){
            resultState.setStateCode(ResultStateCode.INVALID_DATA);
            resultState.setMsg("数据不存在");
        }
        resultState.setData(id);
        return resultState;
    }

    @Override
    public ResultState add(HealthCarePlan inputModel) {
        ResultState<Long> resultState = new ResultState<Long>();
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        inputModel.setCreatedAt(new Date());
        HealthCarePlan entity = new HealthCarePlan();
        BeanUtils.copyProperties(inputModel, entity);
        long sqlResult = healthCarePlanMapper.insert(entity);
        if (!(sqlResult > 0)){
            resultState.setStateCode(ResultStateCode.INVALID_DATA);
            resultState.setMsg("数据插入失败");
        }
        resultState.setData(entity.getId());
        return resultState;
    }

    @Override
    public HealthCarePlan edit(long id) {
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        return healthCarePlanMapper.selectByPrimaryKey(id);
    }

    @Override
    public ResultState doEdit(HealthCarePlan inputModel) {
        DynamicDataContextHolder.setCustomerType(DynamicDataContextHolder.DEFAULT);
        ResultState<Long> resultState = new ResultState<Long>();
        if (!(healthCarePlanMapper.updateByPrimaryKey(inputModel)>0)){
            resultState.setStateCode(ResultStateCode.INVALID_DATA);
            resultState.setMsg("数据不存在");
        }
        resultState.setData(inputModel.getId());
        return resultState;
    }
}
